function Create(self)
	self.LifeTimer = Timer()
	self.timer = 0
	self.Parent = MovableMan:GetMOFromID(self.Sharpness)
	if self.Parent then
		self.Parent = ToActor(self.Parent)
		self.Ctrl = self.Parent:GetController()
		self.TargetPos = self.Parent.ViewPoint	-- A missile fired by AI will home in on the original ViewPoint
		self.step = 5	-- Calculate once every n frames
		self.Grav = SceneMan.GlobalAcc * (TimerMan.DeltaTimeSecs * self.step)
		self.factor = FrameMan.PPM * TimerMan.DeltaTimeSecs * self.step
		self.acc = 0.6
		self.airLarge = 0.95^self.step
		self.airSmall = 0.995^self.step
	end
end

function Update(self)
	if self.LifeTimer:IsPastSimMS(5000) then
		self:GibThis()
		return
	end
	
	-- Transform velocity to the projectiles local coordinate system
	local RelVel = self:UnRotateOffset(self.Vel)
	
	if RelVel.X > 35 then RelVel.X = RelVel.X * self.airLarge	-- Air resistance for forward movement
	else RelVel.X = RelVel.X + self.acc	end	-- Acceleration
	
	-- Air resistance for movement Perpendicular to RotAngle
	if math.abs(RelVel.Y) > 15 then RelVel.Y = RelVel.Y * 0.95
	elseif math.abs(RelVel.Y) > 5 then RelVel.Y = RelVel.Y * 0.995 end
	
	-- Transform back to the global coordinate system (X is right)
	self.Vel = self:RotateOffset(RelVel)
	
	if self.timer > 4 then
		self.timer = 1
		if MovableMan:ValidMO(self.Parent) and self.Parent.ClassName ~= "Entity" then 
			if self.Parent:IsPlayerControlled() then
				if self.Ctrl:IsState(Controller.AIM_SHARP) then self.TargetPos = self.Parent.ViewPoint
				else return end
			end
			
			-- Simulate missile flight
			local Vel = Vector(self.Vel.X, self.Vel.Y)
			local Pos = Vector(self.Pos.X, self.Pos.Y)
			local minDist = 10000
			local closeRotAng = 0
			local Range
			local ang
			for i = 1, 9 do
				RelVel = self:UnRotateOffset(Vel)
				RelVel.X = RelVel.X + self.acc * self.step	-- Acceleration
				
				-- Air resistance
				if RelVel.X > 35 then RelVel.X = RelVel.X * self.airLarge end
				if math.abs(RelVel.Y) > 15 then RelVel.Y = RelVel.Y * self.airLarge
				elseif math.abs(RelVel.Y) > 5 then RelVel.Y = RelVel.Y * self.airSmall end
				
				Vel = self:RotateOffset(RelVel)
				Pos = Pos + self.Grav + Vel * self.factor
				
				Range = SceneMan:ShortestDistance(Pos, self.TargetPos, false)
				local dist = Range.Magnitude
				if dist < minDist then
					minDist = math.floor(dist)
					ang = Range.AbsRadAngle
					closeRotAng = Vel.AbsRadAngle
				else
					break
				end
			end
			
			if closeRotAng > ang + 3.1416 then ang = ang - (closeRotAng - 6.2832)
			elseif ang > closeRotAng + 3.1416 then ang = ang - 6.2832 - closeRotAng
			else ang = ang - closeRotAng end
			
			if ang < -0.05 then self.RotAngle = self.RotAngle + math.max(ang/2, -0.2)
			elseif ang > 0.05 then self.RotAngle = self.RotAngle + math.min(ang/2, 0.2) end
		else
			-- OrientToVel
			local minAng = math.min(self.Vel.AbsRadAngle, self.RotAngle)
			self.RotAngle = minAng + (math.max(self.Vel.AbsRadAngle, self.RotAngle) - minAng)/2
		end
	elseif self.LifeTimer:IsPastSimMS(300) then
		self.timer = self.timer + 1
	end
end